/****************************************************************************
 *
 * services.h - headers for services.c
 * Added by binary (76106.1437@compuserve.com)
 * $Id: services.h,v 1.1.1.1 1999/09/01 23:20:37 stskeeps Exp $
 */

#ifndef	SERVICES_HEADER_FILE
#define	SERVICES_HEADER_FILE	1

#define	CSFLAG_TL_FDR	0x0000	/* 0000 0000 0000 0000 */
#define	CSFLAG_TL_SOP	0x0001	/* 0000 0000 0000 0001 */
#define	CSFLAG_TL_AOP	0x0003	/* 0000 0000 0000 0011 */
#define	CSFLAG_TL_NONE	0x0007	/* 0000 0000 0000 0111 */
#define	CSFLAG_OPGUARD	0x0008	/* 0000 0000 0000 1000 */
#define	CSFLAG_IDENT	0x0010	/* 0000 0000 0001 0000 */
#define	CSFLAG_LEAVEOPS	0x0020	/* 0000 0000 0010 0000 */
#define	CSFLAG_PRIVATE	0x0040	/* 0000 0000 0100 0000 */
#define	CSFLAG_RESTRICT	0x0080	/* 0000 0000 1000 0000 */
#define	CSFLAG_ML_FDR	0x0100	/* 0000 0001 0000 0000 */
#define	CSFLAG_ML_SOP	0x0300	/* 0000 0011 0000 0000 */
#define	CSFLAG_ML_AOP	0x0700	/* 0000 0111 0000 0000 */
#define	CSFLAG_ML_ALL	0x0F00	/* 0000 1111 0000 0000 */

#define	NSFLAG_KILL	0x0001	/* 0000 0000 0000 0001 */
#define	NSFLAG_NOMEMO	0x0002	/* 0000 0000 0000 0010 */
#define	NSFLAG_NOOP	0x0004	/* 0000 0000 0000 0100 */
#define	NSFLAG_CSOP	0x0008	/* 0000 0000 0000 1000 */
#define	NSFLAG_SERVADM	0x0010	/* 0000 0000 0001 0000 */
#define	NSFLAG_SERVROOT	0x0020	/* 0000 0000 0010 0000 */

#define	MEMFLAG_NEW	0x0001	/* 0000 0000 0000 0001 */
#define	MEMFLAG_DEL	0x0002	/* 0000 0000 0000 0010 */

#define	RCH_AKICK	-1
#define	RCH_BASIC	0
#define	RCH_VOICE	1
#define	RCH_AOP		2
#define	RCH_SOP		3
#define	RCH_FOUNDER	4
#define	RCH_FDR_NS	5
#define	RCH_FDR_CS	6

#define	RNF_NOTREG	0
#define	RNF_NOTACC	1
#define	RNF_ACCESS	2
#define	RNF_IDENT	3

#define	SAC_AKILL	-2
#define	SAC_IGNORE	-1
#define	SAC_BASIC	0
#define	SAC_CSOP	1
#define	SAC_SERVADM	2
#define	SAC_SERVROOT	3

typedef	struct	RegNick	aRegNick;
typedef	struct	RegChan	aRegChan;
typedef	struct	Memo	aMemo;
typedef	struct	ChanAccEntry	aChanAccEntry;
typedef	struct	NickAccMask	aNickAccMask;
typedef	struct	MLock	CMLock;

struct CMLock {
		long	mode;
		char	key[KEYLEN+1];
		int	limit;
};

struct Memo {
		struct	Memo	*next, *prev;
		char	sender[NICKLEN+1];
		time_t	sendtime;
		char	*text;
		int	flags;
};

struct ChanAccEntry {
		struct	ChanAccEntry	*next, *prev;
		aRegNick	*nick;
		char	*mask;
};

struct NickAccMask {
		struct	NickAccMask	*next, *prev;
		char	mask[USERLEN+HOSTLEN+3];
};

struct RegChan	{
		struct	RegChan	*next, *prev, *hnext, *hprev;
		aChanAccEntry	*aop;
		aChanAccEntry	*sop;
		aChanAccEntry	*akick;
		aChanAccEntry	*voice;
		aRegNick	*founder;
		char	name[CHANNELLEN+1];
		char	passwd[PASSWDLEN+1];
		char	desc[TOPICLEN+1];
		char	url[HOSTLEN+USERLEN+18];
		char	topic[TOPICLEN+1];
		int	flags;
		struct	CMLock	mlockyes;
		struct	CMLock	mlockno;
		time_t	regtime, lasttime;
};

struct RegNick {
		struct	RegNick	*next, *prev, *hnext, *hprev;
		aNickAccMask	*access_list;
		aMemo		*memo;
		aClient		*user;
		char	name[NICKLEN+1];
		char	passwd[PASSWDLEN+1];
		char	url[HOSTLEN+USERLEN+18];
		char	lastaddy[USERLEN+HOSTLEN+2];
		char	lastname[REALLEN+1];
		int	flags, killstage;
		time_t	regtime, lasttime, killtime;
};

#endif
